#include <stdio.h>
#include <math.h>

#include "if2.h"


void                 If2Read();                           /* if2read.c        */

double                TSECND();                           /* if2timer.c       */
void            StopProfiler();
void           StartProfiler();

void              EnterScope(),            MakeGraph();   /* if2build.c       */
void                MakeInfo(),             MakeEdge();
void               MakeConst(),             MakeNode();
void            MakeCompound(),            ExitScope();
void                AddStamp(),          RemoveStamp();
void    AssignSourceFileName(),              MakeAde();
int                  IsStamp();
PINFO               FindInfo();

void              LinkImport(),           LinkExport();   /* if2util.c        */
void            UnlinkImport(),         UnlinkExport();
void         UnlinkAdeImport(),      UnlinkAdeExport();
void           LinkAdeImport(),        LinkAdeExport();
PNODE           FindLastNode(),         FindFunction();
PNODE              LinkGraph();
PCALL         GetNewCallNode();
PNODE               LinkNode();
PNODE             UnlinkNode();
PNODE            UnlinkGraph();
char             *CopyString(),             *MyAlloc();
void                Warning1(),               Error1();
void                  Error2(),           EnterInSet();
PALIST        LinkAssocLists();
PEDGE              EdgeAlloc();
PNODE              NodeAlloc();
PINFO              InfoAlloc();
PADE                AdeAlloc();
PALIST        AssocListAlloc();
PSET                SetAlloc();
PEDGE             FindImport();
PEDGE             FindExport();
int               UsageCount(),          IsAggregate();
void      CreateAndInsertAde();
int             IsAdePresent(),    AreNodesDependent();
int            AreEdgesEqual(),       HasWriteExport();

void                If2Write();                           /* if2write.c       */

void                   If2Up();                           /* if2up.c          */

void                 If2NoOp();                           /* if2noop.c        */

void            If2CallGraph();                           /* if2call.c        */

void       If2ReferenceCount(),      AssignCMPragmas();   /* if2refcnt.c      */

void             If2Classify();                           /* if2class.c       */

void              If2Replace();                           /* if2replace.c     */

void        If2ReadWriteSets();                           /* if2rwsets.c      */

void                  If2Ade();                           /* if2ade.c         */

void      If2ConstGenerators();                           /* if2const.c       */

void                If2Count();                           /* if2count.c       */
void      WriteIf2upWarnings();

void            If2Ownership();                           /* if2owner.c       */
void           OptimizeSwaps();

void    If2ReferenceCountOpt(),     CleanNoOpImports();   /* if2refcntopt.c   */

void        If2RefineGrounds(),    If2PropagateMarks();   /* if2marks.c       */

void             If2Migrate();                            /* if2migrate.c     */

char            *GetNodeName();                           /* if2.c            */

void                    Stop(),                 main();   /* DRIVER FILE      */

int                   strlen();                           /* C LIBRARY STUFF  */
char                 *strcpy();

#ifndef RS6000
char                 *malloc();
int                     free();
#endif

#ifdef CRAY
double                  atof();
#endif


#define OK       0                               /* PROGRAM EXIT STATUS CODES */
#define ERROR    1

#define FALSE    0
#define TRUE     1

extern FILE  *input;                             /* IF1 INPUT  STREAM         */
extern FILE  *output;                            /* IF1 OUTPUT STREAM         */

extern char  *program;                           /* PROGRAM NAME              */

extern char *sfile;                              /* SISAL FILE BEING READ     */
extern PNODE cfunct;                      /* FUNCTION BEING BUILT OR EXAMINED */

extern int    info;               /* DUMP OPTIMIZATION INFO TO stderr?        */
extern int    sgnok;              /* ARE SIGNED ARITHMETIC CONSTANTS ALLOWED? */
extern int    mig;                /* MIGRATE NODES TOWARD USES?               */

extern int    maxint;                   /* MAXIMUM INTEGER READ FROM IF1 FILE */
extern PINFO  integer;                  /* INTEGER SYMBOL TABLE ENTRY         */
extern int    line;        /* LINE NUMBER OF PREVIOUSLY READ LINE OF IF1 FILE */

extern PINFO  ihead;                    /* SYMBOL TABLE HEAD POINTER          */
extern PINFO  itail;                    /* SYMBOL TABLE TAIL POINTER          */

extern PNODE  fhead;                    /* HEAD OF SORTED FUNCTION GRAPH LIST */
extern PNODE  ftail;                    /* TAIL OF SORTED FUNCTION GRAPH LIST */
extern PNODE  nohead;                   /* NoOp NODE LIST HEAD                */
extern PNODE  notail;                   /* NoOp NODE LIST TAIL                */
extern PNODE  chead;                    /* COMPOUND NODE LIST HEAD            */
extern PNODE  ctail;                    /* COMPOUND NODE LIST TAIL            */
extern PCALL  cghead;                   /* CALL GRAPH TRUNK HEAD              */
extern PCALL  cgtail;                   /* CALL GRAPH TRUNK TAIL              */
extern PSET   gshead;                   /* GLOBAL READ/WRITE SET LIST HEAD    */
extern PSET   gstail;                   /* GLOBAL READ/WRITE SET LIST TAIL    */
extern PEDGE  dghead;                   /* DATA GROUND EDGE LIST HEAD         */
extern PEDGE  dgtail;                   /* DATA GROUND EDGE LIST TAIL         */
extern PNODE  cohead;               /* CONSTANT AGGREGATE GENERATOR LIST HEAD */
extern PNODE  cotail;               /* CONSTANT AGGREGATE GENERATOR LIST TAIL */


extern PNODE  glstop;                   /* HEADER OF FUNCTION GRAPH LIST      */
extern char  *stamps[];                 /* ARRAY OF IF1 STAMPS 0 to 127       */
extern char  *cnames[];                 /* COMPOUND NODE NAMES                */
extern char  *snames[];                 /* SIMPLE NODE NAMES                  */
extern char  *atnames[];                /* IF2 AT-NODE NAMES                  */
extern char  *gnames[];                 /* GRAPH NODE NAMES                   */
extern PRAGS  pragmas;        /* PRAGMAS FORM CURRENTLY READ LINE OF IF1 FILE */

extern int    minopt;               /* ONLY PERFORM MINIMAL OPTIMIZATION?     */
extern int    cagg;                 /* MARK CONSTANT AGGREGATES?              */
extern int    ststr;                /* IDENTIFY SINGLE THREADED STREAMS?      */

extern int    univso;                          /* UNIVERSAL STREAM OWNERSHIP? */
extern int    univao;                          /* UNIVERSAL ARRAY  OWNERSHIP? */
extern int    cycle;                           /* COUNT OF CYCLE CAUSING ADEs */
extern int    cmig;                            /* COUNT OF MIGRATED NODES     */
extern int    seqimp;

extern int    swcnt;                           /* COUNT OF SWAP OPTIMIZATIONS */
extern int    hnoops;                          /* COUNT OF HOISTED NoOp NODES */

extern int    prof;                            /* PROFILE THE OPTIMIZER?      */
